<template>
  <ModalDefault
    title="Choose wallet"
    ref="changeAccounts"
    @submit="submitNewAccount">
    <div class="modal_default-inner">
      <div
        v-for="(item, key) in accountList"
        :key="key"
        class="modal_default-list flex flex-between flex-middle"
        :class="{'modal_default-list-checked': item===currentAccount}">
        <div
          class="flex flex-middle modal_default-list-checkbox"
          @click="chooseAccount(item)">
          <Checkbox :value="item===currentAccount"></Checkbox>
          <div class="modal_default-list-name">{{item.account_name || item}}</div>
        </div>
        <div
          class="modal_default-list-amount"
          v-if="priceMap[item]!==undefined">
          {{priceMap[item]}} EOS
        </div>
        <div v-else>Loading...</div>
      </div>
    </div>
  </ModalDefault>
</template>

<script>
  import ModalDefault from '~/components/UI/Modal/Default';
  import Checkbox from '~/components/UI/Checkbox';
  import BSwitch from '~/components/UI/Switch';

  export default {
    name: "TheSelectNetwork",
    data() {
      return {
        accountList: [],
        priceMap: {},
        currentAccount: '',
      }
    },
    components: {
      BSwitch,
      ModalDefault,
      Checkbox
    },
    computed: {
      pubKey() {
        return this.$store.state.wallet.publicKey;
      },
    },
    methods: {
      submitNewAccount() {
        this.$store.dispatch('common/setAccount', this.currentAccount);
        this.show(false);
        this.$emit('submit');
      },
      chooseAccount(account) {
        if (this.currentAccount === account) return;
        this.currentAccount = account;
      },
      selectAccounts(accounts) {
        const accountList = accounts.accountsList.reverse();
        this.accountList = accountList;
        this.currentAccount = accounts.currentAccount;
        accountList.forEach(async item => {
          const balance = await this.$store.dispatch('wallet/checkBalance', {accountname: item, needCommit: false});
          this.$set(this.priceMap, item, balance);
          //this.priceMap[item] = balance;
        });
      },
      show(show = true) {
        this.$refs['changeAccounts'].show(show);
      },
    }
  }
</script>
